//	Compiler: JDK 1.0.2 
//				j
// Digitime_8a  p8, p9, p19, p21  random + animation + time  + date
// Based on the tutorial from JavaBoutique by Johannes Wallroth
// Created by Severin Jelinek, Dec 29, 2000 
// Modified Mar 1, 2002 from Digitime_7 
// 2_0301     with sun-dial 

//	test, hemisphere 

import java.awt.*;
import java.applet.*;

// We need to import the util package for the time functions
import java.util.*;

public class Digitime_8a extends Applet implements Runnable 
{
	Thread runner;
	int randomNumber, randomNumber2;
	String zeroOne = "";

	Image buffer;
	Graphics gBuffer;

	int x2 = 10;
	int y2 = 30;
	boolean moveRight = true;
	boolean moveDown = true;
	String txt;

	String Year_corr, Month_corr, Day_new;
	int Date_new;
	boolean northern = true;



	//Init is called first, do any initialisation here
	public void init() 
	{
	//create graphics buffer, the size of the applet
		buffer = createImage(size().width,size().height);
        	gBuffer = buffer.getGraphics();


	// text and hemisphere from HTML

		txt = getParameter("text_1");
		String hemi = getParameter("hemisphere");
		if (hemi.substring(0,1).equals ("s") || hemi.substring(0,1).equals ("S"))
			northern = false;
	}

//******

	public void run()
	{
		while(true) 
		{
			//halt the thread for 0.5 seconds here	
			try {runner.sleep(500);}
			catch (Exception e) {}
			repaint();
		}
	}

//****************

	//is needed to avoid erasing the background by Java
	public void update(Graphics g)
	{	paint(g);	}

//+++++++++++++++++

	public void paint (Graphics g)
	{

//----------------------------------

//===========

		randomNumber = (int)(Math.random() * 10);
		randomNumber2 = (int)(Math.random() * 2);
//--------------

		int dif = randomNumber * 4;
		int dif2 = randomNumber2 * 20;

		//paint the background gray
		gBuffer.setColor(Color.red);
		gBuffer.fillRect(0,0,size().width,size().height);
		gBuffer.setColor(Color.gray);
		gBuffer.fillRect(10,5,size().width - 10,size().height - 5);

//        -------------------

			//move the magenta square right until it touches border
			//then set flag "moveRight" to false
			if (moveRight == true)
			{
				if (x2 < size().width - 60)
					x2 += 2;
				else
					moveRight = false;
			}

			//if flag "moveRight" is false the magenta square moves
			//left until it touches left border, then switch direction
			if (moveRight == false)
			{
				if (x2 > 0)
					x2 -= 2;
				else
					moveRight = true;
			}

//****************

			//move the magenta square down until it touches lower border
			//then set flag "moveDown" to false
			if (moveDown == true)
			{
				if (y2 < size().height - 60)
					y2++;
				else
					moveDown = false;
			}

			//if flag "moveDown" is false the magenta square moves
			//up until it touches upper border, then switch direction
			if (moveDown == false)
			{
				if (y2 > 0)
					y2--;
				else
					moveDown = true;
			}



//xxxxxxxxx   magenta rectangle with time & date

		//Magenta rectangle with round corners
			gBuffer.setColor(Color.magenta);
			gBuffer.fillRoundRect(x2,y2,60,60,20,40);
   
		//create a new time object
			Date today = new Date();

		//get the seconds, minutes and hours
			int sec = today.getSeconds();
			int min = today.getMinutes();
			int hour = today.getHours();
				
			String secStr, minStr, hourStr;
				
				//copy the time integers to our string objects
				//if values are less than 10 we add a 0
				if(hour < 10)
					hourStr = "0" + hour;
				else
					hourStr = "" + hour;

				if(min < 10)
					minStr = "0" + min;
				else
					minStr = "" + min;

				if(sec < 10)
					secStr = "0" + sec;
				else
					secStr = "" + sec;

				//set a new font we create "on the fly"
				gBuffer.setFont(new Font("Helvetica",Font.BOLD,10));
				gBuffer.setColor(Color.yellow);
		gBuffer.drawString(hourStr + ":" + minStr + ":" + secStr,x2 + 9,y2 + 16);


// ************  Digitime_8a, date

		Date_new = today.getDate();

		Month_corr = today.toString();
		Month_corr = Month_corr.substring(4,7);
		gBuffer.drawString(Month_corr + " " + Date_new,x2 + 8,y2 + 28);

		Year_corr = today.toString();
		Year_corr = Year_corr.substring(Year_corr.length()  - 4, Year_corr.length());
		gBuffer.drawString("   "+ Year_corr,x2 + 18,y2 + 40);

		Day_new = today.toString();
		Day_new = Day_new.substring(0,3);
		gBuffer.drawString(" -- " + Day_new + " -- ",x2 + 8,y2 + 52);

//xxxxxxxxx 

// -----------------
     

		//Red square 

			gBuffer.setColor(Color.red);
			gBuffer.fillRect(80,40 - randomNumber,20 + randomNumber2 * 3,20 + randomNumber);

			gBuffer.drawLine(120,0,300,120);

		//Yellow circle

			gBuffer.setColor(Color.yellow);
			gBuffer.fillOval(60,70,20,20);



 //	=================================== 

	//Orange or darkgray oval with sun-dial 

		if (randomNumber == 7)
		{
			gBuffer.setColor(Color.darkGray);
		}
		else
		{
			gBuffer.setColor(Color.orange);
		}

			gBuffer.fillOval(135,30,50,20);

		if (randomNumber == 7)
		{
			gBuffer.setColor(Color.orange);
		}
		else
		{
			gBuffer.setColor(Color.darkGray);
		}

		int sdx, sdy, x_corr; 
		float hour_sd; 

//implicite conversion occurs 

		hour_sd = hour + (float)min/60;  
		if (hour_sd > 18) 
			hour_sd = hour_sd - 12; 
		else if (hour_sd < 6) 
			hour_sd = hour_sd + 12; 

		if (northern != true) 
			hour_sd = 24 - hour_sd; 

//	6: pi, 12: pi/2, 18: 0    Math.PI is also possible 

//	3.14 - 3.14 * (hour_sd - 6)/12    y-coordinate goes down 

		sdx = (int)(13 * Math.cos(3.14 - 3.14 * (hour_sd - 6)/12)); 
		sdy = (int)(13 * Math.sin(3.14 - 3.14 * (hour_sd - 6)/12)); 

		x_corr = (int)(hour_sd - 12); 

//	135,30,50,20	160,35,160,48 
//	160,35,160 + sdx + x_corr,35 + sdy 

		gBuffer.drawLine(160,35,160 + sdx + x_corr,35 + sdy);


//	135,30,50,20	160,35,160,43    pointer 

		gBuffer.setColor(Color.blue);

		gBuffer.drawLine(160,35,160,43);

//	=================================== 




		//Magenta rectangle with round corners
			gBuffer.setColor(Color.magenta);
			gBuffer.fillRoundRect(10,30,60,60,20,40);

		//White line
			gBuffer.setColor(Color.white);
			gBuffer.drawLine(0,0,size().width,size().height);


		//Some white texts *************

			gBuffer.setColor(Color.white);
			gBuffer.setFont(new Font("Helvetica",Font.BOLD,18));
			gBuffer.drawString(txt,100,90);

			gBuffer.setColor(Color.green);
			gBuffer.drawLine(1,0,101,300);
			gBuffer.drawLine(0,0,100,300);

//  -----------

			gBuffer.setFont(new Font("Helvetica",Font.BOLD,13 + dif));
		
			gBuffer.setColor(Color.white);
			gBuffer.drawString("" + randomNumber,25 + dif ,75);
			gBuffer.setColor(Color.black);
			gBuffer.drawString("" + randomNumber,35,85 + dif2);
		
			gBuffer.setColor(Color.blue);
			gBuffer.drawString("" + randomNumber,30 + dif,80 + dif);

			gBuffer.setFont(new Font("Helvetica",Font.PLAIN,13));

			if (zeroOne.length() > 9)
			{
				zeroOne = "";
			}

			zeroOne = zeroOne+randomNumber2;

			gBuffer.setColor(Color.white);
			gBuffer.drawString(zeroOne,20 ,20);

//****************	test: 
//****************	test: 
//****************	test: 

// "" + hour_sd + "  " + sdx + "  " + sdy + "  " + x_corr + "  " + northern 

			gBuffer.drawString("" + hour_sd + "  " + sdx + "  " + sdy + "  " + x_corr + "  " + northern,30,120);
			gBuffer.drawString("hour_sd, sdx, sdy, x_corr, northern",5,135);
			gBuffer.drawString("j  " + Math.PI + "  " + (float)min/60,30,150); 

//****************

		//copy the buffer to the screen (no flickering!)

			g.drawImage (buffer,0,0,this);
	}

//+++++++++++++++++
        
	public void start() { if (runner == null) { runner = new Thread(this); runner.start(); } }
	    
	public void stop() { if (runner != null) { runner.stop(); runner = null; } }

	public void destroy() { runner = null; }

}


